// Unit: OnStart

var gDriver_Modbus = "Modbus TCP Server (Slave mode)";
var ModbusTCP_tags = [ //Если переменная не для разбора бит, то index ставить -1 (хотя любой можно)
    {tag: "Generator_130_DOset1", tag_prevstate: "Server.Tags.Gen_130_DOset1_PrevState", type: "bits_ro", place_in_arry: 0, bits_used: 11},
    {tag: "Generator_135_DOset1", tag_prevstate: "Server.Tags.Gen_135_DOset1_PrevState", type: "bits_ro", place_in_arry: 1, bits_used: 1}
    ];
var ModbusTCP_virt_registers = [
    [
        {virtvar: "Server.Tags.Gen_130_05_GenInOFF", bit: 5},
        {virtvar: "Server.Tags.Gen_130_06_GenInAUTO", bit: 6},
        {virtvar: "Server.Tags.Gen_130_07_GenInMANUAL", bit: 7},
        {virtvar: "Server.Tags.Gen_130_08_GenStopped", bit: 8},
        {virtvar: "Server.Tags.Gen_130_09_GenStoppedAlarm", bit: 9},
        {virtvar: "Server.Tags.Gen_130_10_ReadyToRun", bit: 10},
        {virtvar: "Server.Tags.Gen_130_11_ReadyForLoad", bit: 11},
        {virtvar: "Server.Tags.Gen_130_12_AlarmsEnabled", bit: 12},
        {virtvar: "Server.Tags.Gen_130_13_GenRunning", bit: 13},
        {virtvar: "Server.Tags.Gen_130_14_CommonWarning", bit: 14},
        {virtvar: "Server.Tags.Gen_130_15_CommonAlarm", bit: 15}
    ],
    [
        {virtvar: "Server.Tags.Gen_135_05_GenInOFF", bit: 5}
    ],
    ];


function Modbus_getBits (value, value_prev, index, bit) {
    
};

function ModbusTCP_Parse (name, value)
{
    for (var i = 0; i < ModbusTCP_tags.length; i++){
        //IR.Log("i = " + i);
        if (name == ModbusTCP_tags[i].tag) {//Определяем изменившийся текс
            var value_prev = IR.GetVariable(ModbusTCP_tags[i].tag_prevstate);
            if ((value!=value_prev)&&(ModbusTCP_tags[i].type = "bits_ro")) {//Проверяем, что тэг изменил значение и что его нужно парсить и что он категории read only
                IR.SetVariable(ModbusTCP_tags[i].tag_prevstate, value); //Запоминаем состояние которое будет "предудущим" в следующем вызове функции
                var j_end = ModbusTCP_tags[i].bits_used;
                for (var j = 0; j < j_end; j++ ) {
                    //IR.Log("j = " + j);
                    var value_prev_mask_of_changes = value^value_prev;
                    var indx = ModbusTCP_tags[i].place_in_arry;
                    var bit_mask = 1 << ModbusTCP_virt_registers[indx][j].bit;
                    if (value_prev_mask_of_changes & bit_mask) { // Проверка на изменение i бита 
                        IR.Log("Изменился бит - " + ModbusTCP_virt_registers[indx][j].bit);
                        bit_state = (value >> ModbusTCP_virt_registers[indx][j].bit) & 1; // Парсим i-й бит
                        IR.SetVariable(ModbusTCP_virt_registers[indx][j].virtvar, bit_state);
                    };
                };
            };
        
        };
    };
};

function Init_ModbusTCP_var_prevstate (name) { //Инициализация - обнуление при старте виртуальных перменных - предыдущего состояния модбас переменных
    for (var i = 0; i < name.length; i++){
        IR.SetVariable(name[i].tag_prevstate, 0);
    };    
};
    

function Start ()
{ 
    IR.AddListener(IR.EVENT_TAG_CHANGE, IR.GetDevice(gDriver_Modbus), ModbusTCP_Parse);
    Init_ModbusTCP_var_prevstate (ModbusTCP_tags);
};




IR.AddListener(IR.EVENT_START, 0, Start ());

IR.AddListener(IR.EVENT_EXIT, 0, function () {
    
});
